
var xval;
var tempval;
var humival;

const chartConfig = {
//以下にチャート表示するデータをセットしていく
    type: 'line',
    data: {
        labels: xval,

        datasets: [{
            type:'line',
            label: '温度',
            data: tempval,
            borderColor: 'red', //線の色
            backgroundColor: 'red', //下を塗りつぶした時の色
            fill: false, //プロット点から下を塗りつぶす
            borderWidth: 1, //線の幅
            pointRadius: 1, //プロットした点の大きさ
            pointHoverBorderWidth: 1, //プロットした点を選択した時に大きく表示するサイズ
            pointStyle: 'triangle', //プロットした点の表示（△）
            tension: 0.5, //線の伸縮
            yAxisID: 'y', //軸のスケールを選択
        },
        {
            type:'line',
            label: '湿度',
            data: humival,
            borderColor: 'blue', //線の色
            backgroundColor: 'blue', //下を塗りつぶした時の色
            fill: false, //プロット点から下を塗りつぶす
            borderWidth: 1, //線の幅
            pointRadius: 1, //プロットした点の大きさ
            pointHoverBorderWidth: 1, //プロットした点を選択した時に大きく表示するサイズ
            pointStyle: 'rect', //プロットした点の表示（△）
            tension: 0.5, //線の伸縮
            yAxisID: 'y2', //軸のスケールを選択
        }]
    },
    options: {
        responsive: true,
        
        //表示タイトルをつける場合 タイトルを含めたキャンパスの高さとなる
        plugins: { 
            title: {
                display: true,
                text: '温度湿度の変化',
                font: {
                    size: 20
                }
            },
        },
        //表示タイトルをつける場合--end--
        scales: {
            x: {
                display: true,
                ticks: {
                    display: true
                },
                //X軸のタイトルを入れる場合
                title: {
                    display: true,
                    text: 'プロット数/minute',
                    color: 'black',
                    font: {
                        size: 16
                    }
                },
    
                //X軸のタイトルを入れる場合--end--
                gridLineItems: {
                    display: true,
                }
            },
            y: {
                display: true, //y軸を表示するか
                min: 0,
                max: 100,
                ticks: {
                    display: true, //目盛りを表示するか
                    color: 'red',
                },
                //Y軸のタイトルを入れる場合
                title: {
                    display: true, //ｙ軸のタイトルを表示するか
                    text: '温度[℃]',
                    color: 'red',
                    font: {
                        size: 16
                    }
                },
                //Y軸のタイトルを入れる場合--end--
            },
            y2: {
                display: true, //y2軸を表示するか
                min: 0,
                max: 100,
                position: 'right', //軸を右側に表示
                ticks:{
                    display: true,  //目盛りを表示するか
                    color: 'blue',
                    
                },
                //y2軸のタイトルを入れる場合
                title: {
                    display: true, //y2軸のタイトルを表示するか
                    text: '湿度[%]',
                    color: 'blue',
                    font: {
                        size: 16
                    }
                },
                //y2軸のタイトルを入れる場合--end--       
            }
        }
    }
};

/* Chartのグラフを生成 */
window.onload = () => {
    let ctx = document.getElementById("temp-humid-chart").getContext("2d");
    window.tempHumidChart = new Chart(ctx, chartConfig);
};
/* SebSocketイベントのインスタンスを生成 */
var ws = new WebSocket('ws://' + window.location.hostname + ':81/');
/* WebSocketがメッセージを受信 */
ws.onmessage = function(evt){
    var i;
    
    obj = JSON.parse(evt.data);//JSONファイルの展開
    xval = obj["X"];
    tempval = obj["Temp"];
    humival = obj["Humid"];

    document.getElementById("latest-temp").innerHTML = tempval[0];
    document.getElementById("latest-humi").innerHTML = humival[0];

    for(i=0; i<600;i++){
        window.tempHumidChart.data.labels.push(xval[i]);
		window.tempHumidChart.data.datasets[0].data.push(tempval[i]);
        window.tempHumidChart.data.datasets[1].data.push(humival[i]);
    }
    window.tempHumidChart.update();
};
/* WebSocketの廃棄 */
ws.onclose = function(evt) {
    ws.close();
};
